=== debian/watch ===
version=3
http://fast.dpdk.org/rel/dpdk-(18.11.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
